#---------------------------
# Question 1

baseball <- read.table("/Users/Thierry/Documents/R/Data/Compstat/baseball.dat",header=TRUE)
attach(baseball)
plot(baseball[,c(1,11:20)])
p<-ncol(baseball)-1


#---------------------------
# Question 2a

initialize<-function(p){
	theta0<-sample(c(0,1),p,replace=TRUE)
	return(theta0)
}

#---------------------------
# Question 2b


aic <-function(theta,data){
  return(AIC(lm(salary~.,data=data[,c(1,which(theta==1)+1)])))     
}
     

   
#---------------------------
# Question 2c
     
neighborhood <- function(theta0){ 
	p<-length(theta0)
	Theta<-matrix(theta0,p,p,byrow=TRUE)
  diag(Theta)<-1-diag(Theta)
	return(Theta)
}

#---------------------------
# Question 2d

# Steepest descent method
local_search <- function(fun,neighbor,theta0,N=1000,data){
	p<-length(theta0)
	obj0<-fun(theta0,data)
	go_on<-TRUE
	t <- 0
	while ((t<N) & go_on){
		t<-t+1
		Theta<-neighbor(theta0)
		Obj <- apply(Theta,1,fun,data)
    i_best<-which.min(Obj)
    obj<-Obj[i_best]
	  if (obj>obj0){   # solution has not improved
	    go_on <- FALSE # stop
	    }
	  else{   # solution has improved
	    theta0<-Theta[i_best,]
	    obj0<-obj
	    }
	  print(c(t,obj0))
	  } # end while
	return(list(objective=obj0,optimum=theta0))
	}

#-----------------
# TEST	
	
theta0<-initialize(p)
# Optimization
opt<-local_search(aic,neighborhood,theta0,100,baseball)
print(which(opt$optimum==1))


#---------------------------
# Question 3a

new <- function(theta0){
	p<- length(theta0)
	i<-sample(p,1)
	theta <- theta0
  theta[i]<-1-theta[i]
  return(theta)
}

#---------------------------
# Question 3b

# Simulated annealing
simulated_annealing <- function(fun,new,theta0,tau0,m0,a,b,taumin,data){
	p<-length(theta0)
	obj0<-fun(theta0,data)
	tau<-tau0
	m<-m0
	while (tau>taumin){
		for(t in 1:m){
			theta<-new(theta0)
			obj<-fun(theta,data)
			proba<-min(1,exp((obj0-obj)/tau))
			if(runif(1)<proba){
				theta0<-theta
				obj0<-obj
			}
		}
		tau<-tau*a
		m<-m+b
	  print(c(tau,m,obj0))
	  } # end while
	return(list(objective=obj0,optimum=theta0))
	}


#---------------------------
# Question 3c

theta0<-initialize(p)

tau0<-10
m0<-10
a<-0.9
b<-10
taumin<-0.01
simulated_annealing(fun=aic,new=new,theta0,tau0,m0,a,b,taumin,data=baseball)
print(which(opt$optimum==1))


# -------------------------------------
# Question 4a

library("GA")

# -------------------------------------
# Question 4b

# Fitness function
aic_fit <- function(theta,data){
	if(all(theta==0)){
		return(-Inf) # if the set of predictors is empty, fitness=-Inf
	} else return(-aic(theta,data))
 }
     
# -------------------------------------
# Question 4c
  
res_ga <- ga(type = "binary",fitness=aic_fit,data=baseball,nBits=p,
             popSize = 100,pcrossover = 1,pmutation = 0.1,elitism=10,
             maxiter = 100,run = 50)
     
 plot(res_ga)
 summary(res_ga)




